/* gitg-convert.c generated by valac 0.40.19, the Vala compiler
 * generated from gitg-convert.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2015 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))



void gitg_convert_utf8_validate_fallback (gchar* * text,
                                          gssize size);
gchar* gitg_convert_convert_fallback (const gchar* text,
                                      gssize size,
                                      const gchar* fallback);
gboolean gitg_convert_convert_and_check (const gchar* text,
                                         gssize size,
                                         const gchar* from_charset,
                                         gchar* * ret);
gchar* gitg_convert_utf8 (const gchar* str,
                          gssize size,
                          const gchar* from_charset);


void
gitg_convert_utf8_validate_fallback (gchar* * text,
                                     gssize size)
{
	gchar* end = NULL;
	g_return_if_fail (*text != NULL);
	while (TRUE) {
		gchar* _tmp0_ = NULL;
		gboolean _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = g_utf8_validate (*text, size, &_tmp0_);
		end = _tmp0_;
		if (!(!_tmp1_)) {
			break;
		}
		_tmp2_ = end;
		*_tmp2_ = '?';
	}
}


gchar*
gitg_convert_convert_fallback (const gchar* text,
                               gssize size,
                               const gchar* fallback)
{
	gchar* result = NULL;
	gchar* res = NULL;
	gchar* _tmp0_;
	gsize read = 0UL;
	GString* str = NULL;
	GString* _tmp1_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* retval = NULL;
	GString* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GString* _tmp18_;
	gssize _tmp19_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	g_return_val_if_fail (fallback != NULL, NULL);
	_tmp0_ = g_strdup ("");
	res = _tmp0_;
	_tmp1_ = g_string_new ("");
	str = _tmp1_;
	while (TRUE) {
		{
			gchar* _tmp2_ = NULL;
			gsize _tmp3_ = 0UL;
			gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp4_ = g_convert (text, size, "UTF-8", "ASCII", &_tmp3_, NULL, &_inner_error0_);
			read = _tmp3_;
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch100_g_error;
			}
			_tmp5_ = _tmp2_;
			_tmp2_ = NULL;
			_g_free0 (res);
			res = _tmp5_;
			_g_free0 (_tmp2_);
			break;
		}
		goto __finally100;
		__catch100_g_error:
		{
			GString* _tmp10_;
			gsize _tmp11_;
			gsize _tmp12_;
			g_clear_error (&_inner_error0_);
			_inner_error0_ = NULL;
			{
				gchar* _tmp6_ = NULL;
				gsize _tmp7_;
				gchar* _tmp8_;
				GString* _tmp9_;
				_tmp7_ = read;
				_tmp8_ = g_convert (text, (gssize) _tmp7_, "UTF-8", "ASCII", NULL, NULL, &_inner_error0_);
				_tmp6_ = _tmp8_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch101_g_error;
				}
				_tmp9_ = str;
				g_string_append (_tmp9_, _tmp6_);
				_g_free0 (_tmp6_);
			}
			goto __finally101;
			__catch101_g_error:
			{
				g_clear_error (&_inner_error0_);
				_inner_error0_ = NULL;
			}
			__finally101:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_string_free0 (str);
				_g_free0 (res);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp10_ = str;
			g_string_append (_tmp10_, fallback);
			_tmp11_ = read;
			text = (const gchar*) (((guint8*) text) + ((gint) (_tmp11_ + 1)));
			_tmp12_ = read;
			size = size - ((gssize) _tmp12_);
		}
		__finally100:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_string_free0 (str);
			_g_free0 (res);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp13_ = str;
	_tmp14_ = res;
	g_string_append (_tmp13_, _tmp14_);
	_tmp15_ = str;
	_tmp16_ = _tmp15_->str;
	_tmp17_ = g_strdup (_tmp16_);
	retval = _tmp17_;
	_tmp18_ = str;
	_tmp19_ = _tmp18_->len;
	gitg_convert_utf8_validate_fallback (&retval, _tmp19_);
	result = retval;
	_g_string_free0 (str);
	_g_free0 (res);
	return result;
}


gboolean
gitg_convert_convert_and_check (const gchar* text,
                                gssize size,
                                const gchar* from_charset,
                                gchar* * ret)
{
	gchar* _vala_ret = NULL;
	gboolean result = FALSE;
	gsize read = 0UL;
	gsize written = 0UL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (text != NULL, FALSE);
	g_return_val_if_fail (from_charset != NULL, FALSE);
	_g_free0 (_vala_ret);
	_vala_ret = NULL;
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
		gsize _tmp2_ = 0UL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gsize _tmp5_;
		_tmp3_ = g_convert (text, size, "UTF-8", from_charset, &_tmp1_, &_tmp2_, &_inner_error0_);
		read = _tmp1_;
		written = _tmp2_;
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch102_g_error;
		}
		_tmp4_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (_vala_ret);
		_vala_ret = _tmp4_;
		_tmp5_ = read;
		if (_tmp5_ == ((gsize) size)) {
			gsize _tmp6_;
			_tmp6_ = written;
			gitg_convert_utf8_validate_fallback (&_vala_ret, (gssize) _tmp6_);
			result = TRUE;
			_g_free0 (_tmp0_);
			if (ret) {
				*ret = _vala_ret;
			} else {
				_g_free0 (_vala_ret);
			}
			return result;
		}
		_g_free0 (_tmp0_);
	}
	goto __finally102;
	__catch102_g_error:
	{
		g_clear_error (&_inner_error0_);
		_inner_error0_ = NULL;
	}
	__finally102:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp7_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp7_;
	}
	result = FALSE;
	if (ret) {
		*ret = _vala_ret;
	} else {
		_g_free0 (_vala_ret);
	}
	return result;
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = string_length;
		start = _tmp2_ + start;
	}
	if (end < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		end = _tmp3_ + end;
	}
	if (start >= ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		_tmp4_ = start <= _tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	g_return_val_if_fail (_tmp4_, NULL);
	if (end >= ((glong) 0)) {
		glong _tmp7_;
		_tmp7_ = string_length;
		_tmp6_ = end <= _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	g_return_val_if_fail (_tmp6_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp8_;
	return result;
}


gchar*
gitg_convert_utf8 (const gchar* str,
                   gssize size,
                   const gchar* from_charset)
{
	gchar* result = NULL;
	gchar* locale_charset = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp12_;
	g_return_val_if_fail (str != NULL, NULL);
	if (size == ((gssize) -1)) {
		gint _tmp0_;
		gint _tmp1_;
		_tmp0_ = strlen (str);
		_tmp1_ = _tmp0_;
		size = (gssize) _tmp1_;
	}
	if (from_charset == NULL) {
		if (g_utf8_validate (str, size, NULL)) {
			gchar* _tmp2_;
			_tmp2_ = string_slice (str, (glong) 0, (glong) size);
			result = _tmp2_;
			return result;
		}
	} else {
		gchar* ret = NULL;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_;
		if (g_ascii_strcasecmp (from_charset, "UTF-8") == 0) {
			gchar* _tmp3_;
			_tmp3_ = string_slice (str, (glong) 0, (glong) size);
			_g_free0 (ret);
			ret = _tmp3_;
			gitg_convert_utf8_validate_fallback (&ret, size);
			result = ret;
			return result;
		}
		_tmp5_ = gitg_convert_convert_and_check (str, size, from_charset, &_tmp4_);
		_g_free0 (ret);
		ret = _tmp4_;
		if (_tmp5_) {
			result = ret;
			return result;
		}
		_g_free0 (ret);
	}
	_tmp7_ = g_get_charset (&_tmp6_);
	_g_free0 (locale_charset);
	_tmp8_ = g_strdup (_tmp6_);
	locale_charset = _tmp8_;
	if (!_tmp7_) {
		gchar* ret = NULL;
		const gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gboolean _tmp11_;
		_tmp9_ = locale_charset;
		_tmp11_ = gitg_convert_convert_and_check (str, size, _tmp9_, &_tmp10_);
		_g_free0 (ret);
		ret = _tmp10_;
		if (_tmp11_) {
			result = ret;
			_g_free0 (locale_charset);
			return result;
		}
		_g_free0 (ret);
	}
	_tmp12_ = gitg_convert_convert_fallback (str, size, "?");
	result = _tmp12_;
	_g_free0 (locale_charset);
	return result;
}



