/* gitg-notifications.c generated by valac 0.40.19, the Vala compiler
 * generated from gitg-notifications.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include "libgitg-ext.h"
#include <gtk/gtk.h>
#include <gee.h>


#define GITG_TYPE_NOTIFICATIONS (gitg_notifications_get_type ())
#define GITG_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_NOTIFICATIONS, GitgNotifications))
#define GITG_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_NOTIFICATIONS, GitgNotificationsClass))
#define GITG_IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_NOTIFICATIONS))
#define GITG_IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_NOTIFICATIONS))
#define GITG_NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_NOTIFICATIONS, GitgNotificationsClass))

typedef struct _GitgNotifications GitgNotifications;
typedef struct _GitgNotificationsClass GitgNotificationsClass;
typedef struct _GitgNotificationsPrivate GitgNotificationsPrivate;
enum  {
	GITG_NOTIFICATIONS_0_PROPERTY,
	GITG_NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* gitg_notifications_properties[GITG_NOTIFICATIONS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block62Data Block62Data;
typedef struct _Block63Data Block63Data;
typedef struct _Block64Data Block64Data;

struct _GitgNotifications {
	GObject parent_instance;
	GitgNotificationsPrivate * priv;
};

struct _GitgNotificationsClass {
	GObjectClass parent_class;
};

struct _GitgNotificationsPrivate {
	GtkOverlay* d_overlay;
	GeeHashMap* d_delay_handles;
	GtkBox* d_box;
	GeeHashMap* d_handles;
};

struct _Block62Data {
	int _ref_count_;
	GitgNotifications* self;
	GitgExtNotification* notification;
};

struct _Block63Data {
	int _ref_count_;
	GitgNotifications* self;
	GtkRevealer* revealer;
	GitgExtNotification* notification;
};

struct _Block64Data {
	int _ref_count_;
	GitgNotifications* self;
	GitgExtNotification* notification;
};


static gpointer gitg_notifications_parent_class = NULL;
static GitgExtNotificationsIface * gitg_notifications_gitg_ext_notifications_parent_iface = NULL;

GType gitg_notifications_get_type (void) G_GNUC_CONST;
#define GITG_NOTIFICATIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GITG_TYPE_NOTIFICATIONS, GitgNotificationsPrivate))
GitgNotifications* gitg_notifications_new (GtkOverlay* overlay);
GitgNotifications* gitg_notifications_construct (GType object_type,
                                                 GtkOverlay* overlay);
static void gitg_notifications_real_dispose (GObject* base);
static void gitg_notifications_real_add (GitgExtNotifications* base,
                                  GitgExtNotification* notification);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static void __lambda154_ (Block62Data* _data62_,
                   guint delay);
static void ___lambda154__gitg_ext_notification_close (GitgExtNotification* _sender,
                                                guint delay,
                                                gpointer self);
static void gitg_notifications_remove_now (GitgNotifications* self,
                                    GitgExtNotification* notification);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
static void __lambda156_ (Block63Data* _data63_);
static void ___lambda156__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void gitg_notifications_real_remove (GitgExtNotifications* base,
                                     GitgExtNotification* notification,
                                     guint delay);
static Block64Data* block64_data_ref (Block64Data* _data64_);
static void block64_data_unref (void * _userdata_);
static gboolean __lambda155_ (Block64Data* _data64_);
static gboolean ___lambda155__gsource_func (gpointer self);
static void gitg_notifications_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GitgNotifications*
gitg_notifications_construct (GType object_type,
                              GtkOverlay* overlay)
{
	GitgNotifications * self = NULL;
	GtkOverlay* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkOverlay* _tmp8_;
	GtkBox* _tmp9_;
	g_return_val_if_fail (overlay != NULL, NULL);
	self = (GitgNotifications*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (overlay);
	_g_object_unref0 (self->priv->d_overlay);
	self->priv->d_overlay = _tmp0_;
	_tmp1_ = gee_hash_map_new (GITG_EXT_TYPE_NOTIFICATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->d_delay_handles);
	self->priv->d_delay_handles = _tmp1_;
	_tmp2_ = gee_hash_map_new (GITG_EXT_TYPE_NOTIFICATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_ULONG, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->d_handles);
	self->priv->d_handles = _tmp2_;
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 3);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->d_box);
	self->priv->d_box = _tmp3_;
	_tmp4_ = self->priv->d_box;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "notifications");
	_tmp6_ = self->priv->d_box;
	gtk_widget_show ((GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->d_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
	_tmp8_ = self->priv->d_overlay;
	_tmp9_ = self->priv->d_box;
	gtk_overlay_add_overlay (_tmp8_, (GtkWidget*) _tmp9_);
	return self;
}


GitgNotifications*
gitg_notifications_new (GtkOverlay* overlay)
{
	return gitg_notifications_construct (GITG_TYPE_NOTIFICATIONS, overlay);
}


static void
gitg_notifications_real_dispose (GObject* base)
{
	GitgNotifications * self;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp24_;
	self = (GitgNotifications*) base;
	{
		GeeIterator* _id_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->d_delay_handles;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_id_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			guint id = 0U;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			guint _tmp9_;
			_tmp6_ = _id_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _id_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			id = (guint) ((guintptr) _tmp8_);
			_tmp9_ = id;
			g_source_remove (_tmp9_);
		}
		_g_object_unref0 (_id_it);
	}
	_tmp10_ = self->priv->d_delay_handles;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp10_);
	{
		GeeIterator* _notification_it = NULL;
		GeeHashMap* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
		_tmp11_ = self->priv->d_handles;
		_tmp12_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = _tmp13_;
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
		_tmp16_ = _tmp15_;
		_g_object_unref0 (_tmp14_);
		_notification_it = _tmp16_;
		while (TRUE) {
			GeeIterator* _tmp17_;
			GitgExtNotification* notification = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			GitgExtNotification* _tmp20_;
			GeeHashMap* _tmp21_;
			GitgExtNotification* _tmp22_;
			gpointer _tmp23_;
			_tmp17_ = _notification_it;
			if (!gee_iterator_next (_tmp17_)) {
				break;
			}
			_tmp18_ = _notification_it;
			_tmp19_ = gee_iterator_get (_tmp18_);
			notification = (GitgExtNotification*) _tmp19_;
			_tmp20_ = notification;
			_tmp21_ = self->priv->d_handles;
			_tmp22_ = notification;
			_tmp23_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, _tmp22_);
			g_signal_handler_disconnect ((GObject*) _tmp20_, (gulong) ((guintptr) _tmp23_));
			_g_object_unref0 (notification);
		}
		_g_object_unref0 (_notification_it);
	}
	_tmp24_ = self->priv->d_handles;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp24_);
	G_OBJECT_CLASS (gitg_notifications_parent_class)->dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
}


static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
	g_atomic_int_inc (&_data62_->_ref_count_);
	return _data62_;
}


static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
		GitgNotifications* self;
		self = _data62_->self;
		_g_object_unref0 (_data62_->notification);
		_g_object_unref0 (self);
		g_slice_free (Block62Data, _data62_);
	}
}


static void
__lambda154_ (Block62Data* _data62_,
              guint delay)
{
	GitgNotifications* self;
	self = _data62_->self;
	gitg_ext_notifications_remove ((GitgExtNotifications*) self, _data62_->notification, delay);
}


static void
___lambda154__gitg_ext_notification_close (GitgExtNotification* _sender,
                                           guint delay,
                                           gpointer self)
{
	__lambda154_ (self, delay);
}


static void
gitg_notifications_real_add (GitgExtNotifications* base,
                             GitgExtNotification* notification)
{
	GitgNotifications * self;
	Block62Data* _data62_;
	GitgExtNotification* _tmp0_;
	GtkRevealer* revealer = NULL;
	GtkRevealer* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
	GtkBox* _tmp8_;
	GeeHashMap* _tmp9_;
	gulong _tmp10_;
	self = (GitgNotifications*) base;
	g_return_if_fail (notification != NULL);
	_data62_ = g_slice_new0 (Block62Data);
	_data62_->_ref_count_ = 1;
	_data62_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (notification);
	_g_object_unref0 (_data62_->notification);
	_data62_->notification = _tmp0_;
	_tmp1_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp1_);
	revealer = _tmp1_;
	gtk_widget_set_margin_top ((GtkWidget*) revealer, 1);
	gtk_revealer_set_transition_duration (revealer, (guint) 500);
	gtk_revealer_set_transition_type (revealer, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
	_tmp2_ = gitg_ext_notification_get_widget (_data62_->notification);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	gtk_container_add ((GtkContainer*) revealer, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = gitg_ext_notification_get_widget (_data62_->notification);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	gtk_widget_show (_tmp7_);
	_g_object_unref0 (_tmp7_);
	gtk_widget_show ((GtkWidget*) revealer);
	_tmp8_ = self->priv->d_box;
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) revealer);
	gtk_revealer_set_reveal_child (revealer, TRUE);
	_tmp9_ = self->priv->d_handles;
	_tmp10_ = g_signal_connect_data (_data62_->notification, "close", (GCallback) ___lambda154__gitg_ext_notification_close, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _data62_->notification, (gpointer) ((guintptr) _tmp10_));
	_g_object_unref0 (revealer);
	block62_data_unref (_data62_);
	_data62_ = NULL;
}


static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
	g_atomic_int_inc (&_data63_->_ref_count_);
	return _data63_;
}


static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
		GitgNotifications* self;
		self = _data63_->self;
		_g_object_unref0 (_data63_->revealer);
		_g_object_unref0 (_data63_->notification);
		_g_object_unref0 (self);
		g_slice_free (Block63Data, _data63_);
	}
}


static void
__lambda156_ (Block63Data* _data63_)
{
	GitgNotifications* self;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	self = _data63_->self;
	_tmp0_ = gitg_ext_notification_get_widget (_data63_->notification);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	gtk_container_remove ((GtkContainer*) _data63_->revealer, _tmp2_);
	_g_object_unref0 (_tmp2_);
	gtk_widget_destroy ((GtkWidget*) _data63_->revealer);
}


static void
___lambda156__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda156_ (self);
}


static void
gitg_notifications_remove_now (GitgNotifications* self,
                               GitgExtNotification* notification)
{
	Block63Data* _data63_;
	GitgExtNotification* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkContainer* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkRevealer* _tmp6_;
	GeeHashMap* _tmp7_;
	gpointer _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_data63_ = g_slice_new0 (Block63Data);
	_data63_->_ref_count_ = 1;
	_data63_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (notification);
	_g_object_unref0 (_data63_->notification);
	_data63_->notification = _tmp0_;
	_tmp1_ = gitg_ext_notification_get_widget (_data63_->notification);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_widget_get_parent (_tmp3_);
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_revealer_get_type ()) ? ((GtkRevealer*) _tmp4_) : NULL);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp3_);
	_data63_->revealer = _tmp6_;
	_tmp7_ = self->priv->d_handles;
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _data63_->notification);
	g_signal_handler_disconnect ((GObject*) _data63_->notification, (gulong) ((guintptr) _tmp8_));
	g_signal_connect_data ((GObject*) _data63_->revealer, "notify::child-revealed", (GCallback) ___lambda156__g_object_notify, block63_data_ref (_data63_), (GClosureNotify) block63_data_unref, 0);
	gtk_revealer_set_reveal_child (_data63_->revealer, FALSE);
	block63_data_unref (_data63_);
	_data63_ = NULL;
}


static Block64Data*
block64_data_ref (Block64Data* _data64_)
{
	g_atomic_int_inc (&_data64_->_ref_count_);
	return _data64_;
}


static void
block64_data_unref (void * _userdata_)
{
	Block64Data* _data64_;
	_data64_ = (Block64Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data64_->_ref_count_)) {
		GitgNotifications* self;
		self = _data64_->self;
		_g_object_unref0 (_data64_->notification);
		_g_object_unref0 (self);
		g_slice_free (Block64Data, _data64_);
	}
}


static gboolean
__lambda155_ (Block64Data* _data64_)
{
	GitgNotifications* self;
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	self = _data64_->self;
	_tmp0_ = self->priv->d_delay_handles;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _data64_->notification, NULL);
	gitg_notifications_remove_now (self, _data64_->notification);
	result = FALSE;
	return result;
}


static gboolean
___lambda155__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda155_ (self);
	return result;
}


static void
gitg_notifications_real_remove (GitgExtNotifications* base,
                                GitgExtNotification* notification,
                                guint delay)
{
	GitgNotifications * self;
	Block64Data* _data64_;
	GitgExtNotification* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp4_;
	self = (GitgNotifications*) base;
	g_return_if_fail (notification != NULL);
	_data64_ = g_slice_new0 (Block64Data);
	_data64_->_ref_count_ = 1;
	_data64_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (notification);
	_g_object_unref0 (_data64_->notification);
	_data64_->notification = _tmp0_;
	_tmp1_ = self->priv->d_delay_handles;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, _data64_->notification)) {
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		_tmp2_ = self->priv->d_delay_handles;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _data64_->notification);
		g_source_remove ((guint) ((guintptr) _tmp3_));
	}
	_tmp4_ = self->priv->d_delay_handles;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, _data64_->notification, (gpointer) ((guintptr) g_timeout_add_full (G_PRIORITY_DEFAULT, delay, ___lambda155__gsource_func, block64_data_ref (_data64_), block64_data_unref)));
	block64_data_unref (_data64_);
	_data64_ = NULL;
}


static void
gitg_notifications_class_init (GitgNotificationsClass * klass)
{
	gitg_notifications_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GitgNotificationsPrivate));
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) gitg_notifications_real_dispose;
	G_OBJECT_CLASS (klass)->finalize = gitg_notifications_finalize;
}


static void
gitg_notifications_gitg_ext_notifications_interface_init (GitgExtNotificationsIface * iface)
{
	gitg_notifications_gitg_ext_notifications_parent_iface = g_type_interface_peek_parent (iface);
	iface->add = (void (*) (GitgExtNotifications*, GitgExtNotification*)) gitg_notifications_real_add;
	iface->remove = (void (*) (GitgExtNotifications*, GitgExtNotification*, guint)) gitg_notifications_real_remove;
}


static void
gitg_notifications_instance_init (GitgNotifications * self)
{
	self->priv = GITG_NOTIFICATIONS_GET_PRIVATE (self);
}


static void
gitg_notifications_finalize (GObject * obj)
{
	GitgNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_NOTIFICATIONS, GitgNotifications);
	_g_object_unref0 (self->priv->d_overlay);
	_g_object_unref0 (self->priv->d_delay_handles);
	_g_object_unref0 (self->priv->d_box);
	_g_object_unref0 (self->priv->d_handles);
	G_OBJECT_CLASS (gitg_notifications_parent_class)->finalize (obj);
}


GType
gitg_notifications_get_type (void)
{
	static volatile gsize gitg_notifications_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_notifications_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgNotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgNotifications), 0, (GInstanceInitFunc) gitg_notifications_instance_init, NULL };
		static const GInterfaceInfo gitg_ext_notifications_info = { (GInterfaceInitFunc) gitg_notifications_gitg_ext_notifications_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gitg_notifications_type_id;
		gitg_notifications_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgNotifications", &g_define_type_info, 0);
		g_type_add_interface_static (gitg_notifications_type_id, GITG_EXT_TYPE_NOTIFICATIONS, &gitg_ext_notifications_info);
		g_once_init_leave (&gitg_notifications_type_id__volatile, gitg_notifications_type_id);
	}
	return gitg_notifications_type_id__volatile;
}



