/* gitg-date.c generated by valac 0.40.19, the Vala compiler
 * generated from gitg-date.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2013 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdesktop-enums.h>


#define GITG_TYPE_DATE (gitg_date_get_type ())
#define GITG_DATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_DATE, GitgDate))
#define GITG_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_DATE, GitgDateClass))
#define GITG_IS_DATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_DATE))
#define GITG_IS_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_DATE))
#define GITG_DATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_DATE, GitgDateClass))

typedef struct _GitgDate GitgDate;
typedef struct _GitgDateClass GitgDateClass;
typedef struct _GitgDatePrivate GitgDatePrivate;
enum  {
	GITG_DATE_0_PROPERTY,
	GITG_DATE_DATE_STRING_PROPERTY,
	GITG_DATE_DATE_PROPERTY,
	GITG_DATE_NUM_PROPERTIES
};
static GParamSpec* gitg_date_properties[GITG_DATE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GITG_DATE_ERROR_INVALID_FORMAT
} GitgDateError;
#define GITG_DATE_ERROR gitg_date_error_quark ()
struct _GitgDate {
	GObject parent_instance;
	GitgDatePrivate * priv;
};

struct _GitgDateClass {
	GObjectClass parent_class;
};

struct _GitgDatePrivate {
	GDateTime* d_datetime;
	gchar* _date_string;
};


static gpointer gitg_date_parent_class = NULL;
static GRegex* gitg_date_s_rfc2822;
static GRegex* gitg_date_s_rfc2822 = NULL;
static GRegex* gitg_date_s_iso8601;
static GRegex* gitg_date_s_iso8601 = NULL;
static GRegex* gitg_date_s_internal;
static GRegex* gitg_date_s_internal = NULL;
static GSettings* gitg_date_s_gnome_interface_settings;
static GSettings* gitg_date_s_gnome_interface_settings = NULL;
static gboolean gitg_date_s_tried_gnome_interface_settings;
static gboolean gitg_date_s_tried_gnome_interface_settings = FALSE;
static gchar** gitg_date_s_months;
static gint gitg_date_s_months_length1;
static gchar** gitg_date_s_months = NULL;
static gint gitg_date_s_months_length1 = 0;
static gint _gitg_date_s_months_size_ = 0;
static GInitableIface * gitg_date_g_initable_parent_iface = NULL;

GQuark gitg_date_error_quark (void);
GType gitg_date_get_type (void) G_GNUC_CONST;
#define GITG_DATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GITG_TYPE_DATE, GitgDatePrivate))
static gboolean gitg_date_fetch_and_set_int (GMatchInfo* info,
                                      const gchar* name,
                                      gint* retval);
static gboolean gitg_date_fetch_and_set_double (GMatchInfo* info,
                                         const gchar* name,
                                         gdouble* retval);
static GDateTime* gitg_date_parse_internal (GMatchInfo* info,
                                     GError** error);
static GDateTime* gitg_date_parse_iso8601 (GMatchInfo* info,
                                    GError** error);
static GDateTime* gitg_date_parse_rfc2822 (GMatchInfo* info,
                                    GError** error);
static gboolean gitg_date_real_init (GInitable* base,
                              GCancellable* cancellable,
                              GError** error);
const gchar* gitg_date_get_date_string (GitgDate* self);
GitgDate* gitg_date_new (const gchar* date,
                         GError** error);
GitgDate* gitg_date_construct (GType object_type,
                               const gchar* date,
                               GError** error);
gchar* gitg_date_for_display (GitgDate* self);
static gboolean gitg_date_get_is_24h (GitgDate* self);
GitgDate* gitg_date_new_for_date_time (GDateTime* dt);
GitgDate* gitg_date_construct_for_date_time (GType object_type,
                                             GDateTime* dt);
GDateTime* gitg_date_parse (const gchar* date,
                            GError** error);
GDateTime* gitg_date_get_date (GitgDate* self);
void gitg_date_set_date_string (GitgDate* self,
                                const gchar* value);
static void gitg_date_finalize (GObject * obj);
static void _vala_gitg_date_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_gitg_date_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


GQuark
gitg_date_error_quark (void)
{
	return g_quark_from_static_string ("gitg_date_error-quark");
}


static gboolean
gitg_date_fetch_and_set_int (GMatchInfo* info,
                             const gchar* name,
                             gint* retval)
{
	gboolean result = FALSE;
	gchar* val = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (info != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = g_match_info_fetch_named (info, name);
	val = _tmp0_;
	_tmp1_ = val;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_g_free0 (val);
		return result;
	}
	_tmp2_ = val;
	*retval = atoi (_tmp2_);
	result = TRUE;
	_g_free0 (val);
	return result;
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}


static gboolean
gitg_date_fetch_and_set_double (GMatchInfo* info,
                                const gchar* name,
                                gdouble* retval)
{
	gboolean result = FALSE;
	gchar* val = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (info != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = g_match_info_fetch_named (info, name);
	val = _tmp0_;
	_tmp1_ = val;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_g_free0 (val);
		return result;
	}
	_tmp2_ = val;
	*retval = double_parse (_tmp2_);
	result = TRUE;
	_g_free0 (val);
	return result;
}


static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, (guint) 0);
	return result;
}


static GDateTime*
gitg_date_parse_internal (GMatchInfo* info,
                          GError** error)
{
	GDateTime* result = NULL;
	gchar* timestamp = NULL;
	gchar* _tmp0_;
	gint64 unixt = 0LL;
	const gchar* _tmp1_;
	gchar* tzs = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_val_if_fail (info != NULL, NULL);
	_tmp0_ = g_match_info_fetch_named (info, "timestamp");
	timestamp = _tmp0_;
	_tmp1_ = timestamp;
	unixt = int64_parse (_tmp1_);
	_tmp2_ = g_match_info_fetch_named (info, "tz");
	tzs = _tmp2_;
	_tmp3_ = tzs;
	if (_tmp3_ != NULL) {
		GDateTime* ret = NULL;
		gint64 _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		GTimeZone* _tmp8_;
		GTimeZone* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		_tmp4_ = unixt;
		_tmp5_ = g_date_time_new_from_unix_utc (_tmp4_);
		ret = _tmp5_;
		_tmp6_ = ret;
		_tmp7_ = tzs;
		_tmp8_ = g_time_zone_new (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_date_time_to_timezone (_tmp6_, _tmp9_);
		_tmp11_ = _tmp10_;
		_g_time_zone_unref0 (_tmp9_);
		result = _tmp11_;
		_g_date_time_unref0 (ret);
		_g_free0 (tzs);
		_g_free0 (timestamp);
		return result;
	} else {
		gint64 _tmp12_;
		GDateTime* _tmp13_;
		_tmp12_ = unixt;
		_tmp13_ = g_date_time_new_from_unix_local (_tmp12_);
		result = _tmp13_;
		_g_free0 (tzs);
		_g_free0 (timestamp);
		return result;
	}
	_g_free0 (tzs);
	_g_free0 (timestamp);
}


static GDateTime*
gitg_date_parse_iso8601 (GMatchInfo* info,
                         GError** error)
{
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	GTimeZone* _tmp0_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* tzs = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GTimeZone* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gdouble _tmp12_;
	GDateTime* _tmp13_;
	g_return_val_if_fail (info != NULL, NULL);
	_tmp0_ = g_time_zone_new_utc ();
	tz = _tmp0_;
	year = 0;
	month = 1;
	day = 1;
	hour = 0;
	minute = 0;
	seconds = 0.0;
	gitg_date_fetch_and_set_int (info, "year", &year);
	gitg_date_fetch_and_set_int (info, "month", &month);
	gitg_date_fetch_and_set_int (info, "day", &day);
	gitg_date_fetch_and_set_int (info, "hour", &hour);
	gitg_date_fetch_and_set_int (info, "minute", &minute);
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
	_tmp1_ = g_match_info_fetch_named (info, "tz");
	tzs = _tmp1_;
	_tmp2_ = tzs;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		GTimeZone* _tmp4_;
		_tmp3_ = tzs;
		_tmp4_ = g_time_zone_new (_tmp3_);
		_g_time_zone_unref0 (tz);
		tz = _tmp4_;
	} else {
		GTimeZone* _tmp5_;
		_tmp5_ = g_time_zone_new_local ();
		_g_time_zone_unref0 (tz);
		tz = _tmp5_;
	}
	_tmp6_ = tz;
	_tmp7_ = year;
	_tmp8_ = month;
	_tmp9_ = day;
	_tmp10_ = hour;
	_tmp11_ = minute;
	_tmp12_ = seconds;
	_tmp13_ = g_date_time_new (_tmp6_, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_);
	result = _tmp13_;
	_g_free0 (tzs);
	_g_time_zone_unref0 (tz);
	return result;
}


static GDateTime*
gitg_date_parse_rfc2822 (GMatchInfo* info,
                         GError** error)
{
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* monthstr = NULL;
	gchar* _tmp0_;
	gint _tmp14_;
	gchar* tzs = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	GTimeZone* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gdouble _tmp27_;
	GDateTime* _tmp28_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (info != NULL, NULL);
	year = 0;
	month = 0;
	day = 1;
	hour = 0;
	minute = 0;
	seconds = (gdouble) 0;
	gitg_date_fetch_and_set_int (info, "year", &year);
	_tmp0_ = g_match_info_fetch_named (info, "month");
	monthstr = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gchar** _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_ = FALSE;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				const gchar* _tmp8_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				_tmp4_ = gitg_date_s_months;
				_tmp4__length1 = gitg_date_s_months_length1;
				if (!(_tmp3_ < _tmp4__length1)) {
					break;
				}
				_tmp6_ = gitg_date_s_months;
				_tmp6__length1 = gitg_date_s_months_length1;
				_tmp7_ = i;
				_tmp8_ = _tmp6_[_tmp7_];
				if (_tmp8_ != NULL) {
					gchar** _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_tmp9_ = gitg_date_s_months;
					_tmp9__length1 = gitg_date_s_months_length1;
					_tmp10_ = i;
					_tmp11_ = _tmp9_[_tmp10_];
					_tmp12_ = monthstr;
					_tmp5_ = g_strcmp0 (_tmp11_, _tmp12_) == 0;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					gint _tmp13_;
					_tmp13_ = i;
					month = _tmp13_;
					break;
				}
			}
		}
	}
	_tmp14_ = month;
	if (_tmp14_ == 0) {
		GError* _tmp15_;
		_tmp15_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid month specified");
		_inner_error0_ = _tmp15_;
		g_propagate_error (error, _inner_error0_);
		_g_free0 (monthstr);
		_g_time_zone_unref0 (tz);
		return NULL;
	}
	gitg_date_fetch_and_set_int (info, "day", &day);
	gitg_date_fetch_and_set_int (info, "hour", &hour);
	gitg_date_fetch_and_set_int (info, "minute", &minute);
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
	_tmp16_ = g_match_info_fetch_named (info, "tz");
	tzs = _tmp16_;
	_tmp17_ = tzs;
	if (_tmp17_ != NULL) {
		const gchar* _tmp18_;
		GTimeZone* _tmp19_;
		_tmp18_ = tzs;
		_tmp19_ = g_time_zone_new (_tmp18_);
		_g_time_zone_unref0 (tz);
		tz = _tmp19_;
	} else {
		GTimeZone* _tmp20_;
		_tmp20_ = g_time_zone_new_local ();
		_g_time_zone_unref0 (tz);
		tz = _tmp20_;
	}
	_tmp21_ = tz;
	_tmp22_ = year;
	_tmp23_ = month;
	_tmp24_ = day;
	_tmp25_ = hour;
	_tmp26_ = minute;
	_tmp27_ = seconds;
	_tmp28_ = g_date_time_new (_tmp21_, _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp26_, _tmp27_);
	result = _tmp28_;
	_g_free0 (tzs);
	_g_free0 (monthstr);
	_g_time_zone_unref0 (tz);
	return result;
}


static gboolean
gitg_date_real_init (GInitable* base,
                     GCancellable* cancellable,
                     GError** error)
{
	GitgDate * self;
	gboolean result = FALSE;
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_;
	GRegex* _tmp9_;
	const gchar* _tmp10_;
	GMatchInfo* _tmp11_ = NULL;
	gboolean _tmp12_;
	GRegex* _tmp18_;
	const gchar* _tmp19_;
	GMatchInfo* _tmp20_ = NULL;
	gboolean _tmp21_;
	GError* _tmp27_;
	gboolean _tmp28_ = FALSE;
	GError* _inner_error0_ = NULL;
	self = (GitgDate*) base;
	_tmp0_ = gitg_date_s_internal;
	_tmp1_ = self->priv->_date_string;
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
	_g_match_info_unref0 (info);
	info = _tmp2_;
	if (_tmp3_) {
		GDateTime* _tmp4_ = NULL;
		GMatchInfo* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp8_;
		_tmp5_ = info;
		_tmp6_ = gitg_date_parse_internal (_tmp5_, &_inner_error0_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp7_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_match_info_unref0 (info);
			return _tmp7_;
		}
		_tmp8_ = _tmp4_;
		_tmp4_ = NULL;
		_g_date_time_unref0 (self->priv->d_datetime);
		self->priv->d_datetime = _tmp8_;
		result = TRUE;
		_g_date_time_unref0 (_tmp4_);
		_g_match_info_unref0 (info);
		return result;
	}
	_tmp9_ = gitg_date_s_iso8601;
	_tmp10_ = self->priv->_date_string;
	_tmp12_ = g_regex_match (_tmp9_, _tmp10_, 0, &_tmp11_);
	_g_match_info_unref0 (info);
	info = _tmp11_;
	if (_tmp12_) {
		GDateTime* _tmp13_ = NULL;
		GMatchInfo* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp17_;
		_tmp14_ = info;
		_tmp15_ = gitg_date_parse_iso8601 (_tmp14_, &_inner_error0_);
		_tmp13_ = _tmp15_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp16_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_match_info_unref0 (info);
			return _tmp16_;
		}
		_tmp17_ = _tmp13_;
		_tmp13_ = NULL;
		_g_date_time_unref0 (self->priv->d_datetime);
		self->priv->d_datetime = _tmp17_;
		result = TRUE;
		_g_date_time_unref0 (_tmp13_);
		_g_match_info_unref0 (info);
		return result;
	}
	_tmp18_ = gitg_date_s_rfc2822;
	_tmp19_ = self->priv->_date_string;
	_tmp21_ = g_regex_match (_tmp18_, _tmp19_, 0, &_tmp20_);
	_g_match_info_unref0 (info);
	info = _tmp20_;
	if (_tmp21_) {
		GDateTime* _tmp22_ = NULL;
		GMatchInfo* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp26_;
		_tmp23_ = info;
		_tmp24_ = gitg_date_parse_rfc2822 (_tmp23_, &_inner_error0_);
		_tmp22_ = _tmp24_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp25_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_match_info_unref0 (info);
			return _tmp25_;
		}
		_tmp26_ = _tmp22_;
		_tmp22_ = NULL;
		_g_date_time_unref0 (self->priv->d_datetime);
		self->priv->d_datetime = _tmp26_;
		result = TRUE;
		_g_date_time_unref0 (_tmp22_);
		_g_match_info_unref0 (info);
		return result;
	}
	_tmp27_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid date format");
	_inner_error0_ = _tmp27_;
	g_propagate_error (error, _inner_error0_);
	_g_match_info_unref0 (info);
	return _tmp28_;
}


GitgDate*
gitg_date_construct (GType object_type,
                     const gchar* date,
                     GError** error)
{
	GitgDate * self = NULL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	self = (GitgDate*) g_object_new (object_type, "date-string", date, NULL);
	g_initable_init (G_TYPE_CHECK_INSTANCE_CAST (self, g_initable_get_type (), GInitable), NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}


GitgDate*
gitg_date_new (const gchar* date,
               GError** error)
{
	return gitg_date_construct (GITG_TYPE_DATE, date, error);
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}


gchar*
gitg_date_for_display (GitgDate* self)
{
	gchar* result = NULL;
	GDateTime* dt = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GTimeSpan t = 0LL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GTimeSpan _tmp5_;
	GTimeSpan _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->d_datetime;
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
	dt = _tmp1_;
	_tmp2_ = g_date_time_new_now_local ();
	_tmp3_ = _tmp2_;
	_tmp4_ = dt;
	_tmp5_ = g_date_time_difference (_tmp3_, _tmp4_);
	_g_date_time_unref0 (_tmp3_);
	t = _tmp5_;
	_tmp6_ = t;
	if (((gdouble) _tmp6_) < (G_TIME_SPAN_MINUTE * 29.5)) {
		gint rounded_minutes = 0;
		GTimeSpan _tmp7_;
		gint _tmp8_;
		_tmp7_ = t;
		rounded_minutes = (gint) round ((gdouble) (((gfloat) _tmp7_) / G_TIME_SPAN_MINUTE));
		_tmp8_ = rounded_minutes;
		if (_tmp8_ == 0) {
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Now"));
			result = _tmp9_;
			_g_date_time_unref0 (dt);
			return result;
		} else {
			gint _tmp10_;
			gint _tmp11_;
			gchar* _tmp12_;
			_tmp10_ = rounded_minutes;
			_tmp11_ = rounded_minutes;
			_tmp12_ = g_strdup_printf (ngettext ("A minute ago", "%d minutes ago", (gulong) _tmp10_), _tmp11_);
			result = _tmp12_;
			_g_date_time_unref0 (dt);
			return result;
		}
	} else {
		GTimeSpan _tmp13_;
		_tmp13_ = t;
		if (_tmp13_ < (G_TIME_SPAN_MINUTE * 45)) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup (_ ("Half an hour ago"));
			result = _tmp14_;
			_g_date_time_unref0 (dt);
			return result;
		} else {
			GTimeSpan _tmp15_;
			_tmp15_ = t;
			if (((gdouble) _tmp15_) < (G_TIME_SPAN_HOUR * 23.5)) {
				gint rounded_hours = 0;
				GTimeSpan _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gchar* _tmp19_;
				_tmp16_ = t;
				rounded_hours = (gint) round ((gdouble) (((gfloat) _tmp16_) / G_TIME_SPAN_HOUR));
				_tmp17_ = rounded_hours;
				_tmp18_ = rounded_hours;
				_tmp19_ = g_strdup_printf (ngettext ("An hour ago", "%d hours ago", (gulong) _tmp17_), _tmp18_);
				result = _tmp19_;
				_g_date_time_unref0 (dt);
				return result;
			} else {
				GTimeSpan _tmp20_;
				_tmp20_ = t;
				if (_tmp20_ < (G_TIME_SPAN_DAY * 7)) {
					gint rounded_days = 0;
					GTimeSpan _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gchar* _tmp24_;
					_tmp21_ = t;
					rounded_days = (gint) round ((gdouble) (((gfloat) _tmp21_) / G_TIME_SPAN_DAY));
					_tmp22_ = rounded_days;
					_tmp23_ = rounded_days;
					_tmp24_ = g_strdup_printf (ngettext ("A day ago", "%d days ago", (gulong) _tmp22_), _tmp23_);
					result = _tmp24_;
					_g_date_time_unref0 (dt);
					return result;
				} else {
					GDateTime* _tmp25_;
					GDateTime* _tmp26_;
					GDateTime* _tmp27_;
					gboolean _tmp28_;
					_tmp25_ = dt;
					_tmp26_ = g_date_time_new_now_local ();
					_tmp27_ = _tmp26_;
					_tmp28_ = g_date_time_get_year (_tmp25_) == g_date_time_get_year (_tmp27_);
					_g_date_time_unref0 (_tmp27_);
					if (_tmp28_) {
						gboolean _tmp29_;
						gboolean _tmp30_;
						_tmp29_ = gitg_date_get_is_24h (self);
						_tmp30_ = _tmp29_;
						if (_tmp30_) {
							GDateTime* _tmp31_;
							gchar* _tmp32_;
							_tmp31_ = dt;
							_tmp32_ = g_date_time_format (_tmp31_, _ ("%b %e, %H:%M"));
							result = _tmp32_;
							_g_date_time_unref0 (dt);
							return result;
						} else {
							GDateTime* _tmp33_;
							gchar* _tmp34_;
							_tmp33_ = dt;
							_tmp34_ = g_date_time_format (_tmp33_, _ ("%b %e, %I:%M %p"));
							result = _tmp34_;
							_g_date_time_unref0 (dt);
							return result;
						}
					} else {
						gboolean _tmp35_;
						gboolean _tmp36_;
						_tmp35_ = gitg_date_get_is_24h (self);
						_tmp36_ = _tmp35_;
						if (_tmp36_) {
							GDateTime* _tmp37_;
							gchar* _tmp38_;
							_tmp37_ = dt;
							_tmp38_ = g_date_time_format (_tmp37_, _ ("%b %e %Y, %H:%M"));
							result = _tmp38_;
							_g_date_time_unref0 (dt);
							return result;
						} else {
							GDateTime* _tmp39_;
							gchar* _tmp40_;
							_tmp39_ = dt;
							_tmp40_ = g_date_time_format (_tmp39_, _ ("%b %e %Y, %I:%M %p"));
							result = _tmp40_;
							_g_date_time_unref0 (dt);
							return result;
						}
					}
				}
			}
		}
	}
	_g_date_time_unref0 (dt);
}


GitgDate*
gitg_date_construct_for_date_time (GType object_type,
                                   GDateTime* dt)
{
	GitgDate * self = NULL;
	GDateTime* _tmp0_;
	g_return_val_if_fail (dt != NULL, NULL);
	self = (GitgDate*) g_object_new (object_type, NULL);
	_tmp0_ = _g_date_time_ref0 (dt);
	_g_date_time_unref0 (self->priv->d_datetime);
	self->priv->d_datetime = _tmp0_;
	return self;
}


GitgDate*
gitg_date_new_for_date_time (GDateTime* dt)
{
	return gitg_date_construct_for_date_time (GITG_TYPE_DATE, dt);
}


GDateTime*
gitg_date_parse (const gchar* date,
                 GError** error)
{
	GDateTime* result = NULL;
	GitgDate* _tmp0_ = NULL;
	GitgDate* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp1_ = gitg_date_new (date, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp2_ = gitg_date_get_date (_tmp0_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
	result = _tmp4_;
	_g_object_unref0 (_tmp0_);
	return result;
}


const gchar*
gitg_date_get_date_string (GitgDate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date_string;
	result = _tmp0_;
	return result;
}


void
gitg_date_set_date_string (GitgDate* self,
                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gitg_date_get_date_string (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_date_string);
		self->priv->_date_string = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY]);
	}
}


GDateTime*
gitg_date_get_date (GitgDate* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->d_datetime;
	result = _tmp0_;
	return result;
}


static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
	return self ? g_settings_schema_source_ref (self) : NULL;
}


static gboolean
gitg_date_get_is_24h (GitgDate* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = gitg_date_s_gnome_interface_settings;
	if (_tmp1_ == NULL) {
		gboolean _tmp2_;
		_tmp2_ = gitg_date_s_tried_gnome_interface_settings;
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GSettingsSchemaSource* source = NULL;
		GSettingsSchemaSource* _tmp3_;
		GSettingsSchemaSource* _tmp4_;
		gchar* schema_id = NULL;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GSettingsSchemaSource* _tmp7_;
		_tmp3_ = g_settings_schema_source_get_default ();
		_tmp4_ = _g_settings_schema_source_ref0 (_tmp3_);
		source = _tmp4_;
		gitg_date_s_tried_gnome_interface_settings = TRUE;
		_tmp5_ = g_strdup ("org.gnome.desktop.interface");
		schema_id = _tmp5_;
		_tmp7_ = source;
		if (_tmp7_ != NULL) {
			GSettingsSchemaSource* _tmp8_;
			const gchar* _tmp9_;
			GSettingsSchema* _tmp10_;
			GSettingsSchema* _tmp11_;
			_tmp8_ = source;
			_tmp9_ = schema_id;
			_tmp10_ = g_settings_schema_source_lookup (_tmp8_, _tmp9_, TRUE);
			_tmp11_ = _tmp10_;
			_tmp6_ = _tmp11_ != NULL;
			_g_settings_schema_unref0 (_tmp11_);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			const gchar* _tmp12_;
			GSettings* _tmp13_;
			_tmp12_ = schema_id;
			_tmp13_ = g_settings_new (_tmp12_);
			_g_object_unref0 (gitg_date_s_gnome_interface_settings);
			gitg_date_s_gnome_interface_settings = _tmp13_;
		}
		_g_free0 (schema_id);
		_g_settings_schema_source_unref0 (source);
	}
	_tmp14_ = gitg_date_s_gnome_interface_settings;
	if (_tmp14_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp15_ = gitg_date_s_gnome_interface_settings;
	result = g_settings_get_enum (_tmp15_, "clock-format") == ((gint) G_DESKTOP_CLOCK_FORMAT_24H);
	return result;
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void
gitg_date_class_init (GitgDateClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	GError* _inner_error0_ = NULL;
	gitg_date_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GitgDatePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_date_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_date_set_property;
	G_OBJECT_CLASS (klass)->finalize = gitg_date_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_STRING_PROPERTY, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY] = g_param_spec_string ("date-string", "date-string", "date-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_PROPERTY, gitg_date_properties[GITG_DATE_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = g_strdup ("Jan");
	_tmp1_ = g_strdup ("Feb");
	_tmp2_ = g_strdup ("Mar");
	_tmp3_ = g_strdup ("Apr");
	_tmp4_ = g_strdup ("May");
	_tmp5_ = g_strdup ("Jun");
	_tmp6_ = g_strdup ("Jul");
	_tmp7_ = g_strdup ("Aug");
	_tmp8_ = g_strdup ("Sep");
	_tmp9_ = g_strdup ("Oct");
	_tmp10_ = g_strdup ("Nov");
	_tmp11_ = g_strdup ("Dec");
	_tmp12_ = g_new0 (gchar*, 13 + 1);
	_tmp12_[0] = NULL;
	_tmp12_[1] = _tmp0_;
	_tmp12_[2] = _tmp1_;
	_tmp12_[3] = _tmp2_;
	_tmp12_[4] = _tmp3_;
	_tmp12_[5] = _tmp4_;
	_tmp12_[6] = _tmp5_;
	_tmp12_[7] = _tmp6_;
	_tmp12_[8] = _tmp7_;
	_tmp12_[9] = _tmp8_;
	_tmp12_[10] = _tmp9_;
	_tmp12_[11] = _tmp10_;
	_tmp12_[12] = _tmp11_;
	gitg_date_s_months = _tmp12_;
	gitg_date_s_months_length1 = 13;
	{
		GRegex* _tmp13_ = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GRegex* _tmp16_;
		GRegex* _tmp17_;
		GRegex* _tmp18_;
		GRegex* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GRegex* _tmp22_;
		GRegex* _tmp23_;
		GRegex* _tmp24_;
		GRegex* _tmp25_ = NULL;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GRegex* _tmp28_;
		GRegex* _tmp29_;
		GRegex* _tmp30_;
		_tmp14_ = g_strconcat ("^\n" \
"			(?<year>[0-9]{4})\n" \
"			(?:\n" \
"				[-.]?(?:\n" \
"					(?<month>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<day>[0-9]{2})\n" \
"					)?\n" \
"				|\n" \
"					W(?<week>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<weekday>[0-9])\n" \
"					)?\n" \
"				)\n" \
"				(?:\n" \
"					[T ](?<hour>[0-9]{2})\n" \
"					(?:\n" \
"						:?\n" \
"						(?<minute>[0-9]{2})\n" \
"						(?:\n" \
"							:?\n" \
"							(?<seconds>[0-9]{2})\n" \
"							(?<tz>\n" \
"								(?<tzutc>Z) |\n" \
"								[+-](?<tzhour>[0-9]{2})\n" \
"								(?:\n" \
"									:?\n" \
"									(?<tzminute>[0-9]{2})\n" \
"								)?\n" \
"							)?\n" \
"						)?\n" \
"					)?\n" \
"				)?\n" \
"			)?\n" \
"		", "$", NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_regex_new (_tmp15_, G_REGEX_EXTENDED, 0, &_inner_error0_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		_tmp13_ = _tmp17_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch32_g_error;
		}
		_tmp18_ = _tmp13_;
		_tmp13_ = NULL;
		_g_regex_unref0 (gitg_date_s_iso8601);
		gitg_date_s_iso8601 = _tmp18_;
		_tmp20_ = g_strconcat ("^\n" \
"			(?:\n" \
"				[\\s]*(?<dayofweek>Mon|Tue|Wed|Thu|Fri|Sat|Sun)\n" \
"				,\n" \
"			)?\n" \
"			[\\s]*(?<day>[0-9]{1,2})\n" \
"			[\\s]+\n" \
"				(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\n" \
"			[\\s]+\n" \
"				(?<year>[0-9]{4})\n" \
"			[\\s]+\n" \
"				(?<hour>[0-9]{2})\n" \
"				:\n" \
"				(?<minute>[0-9]{2})\n" \
"				(?:\n" \
"					:\n" \
"					(?<seconds>[0-9]{2})\n" \
"				)?\n" \
"			[\\s]+\n" \
"			(?<tz>\n" \
"				[+-]\n" \
"				(?<tzhour>[0-9]{2})\n" \
"				(?<tzminute>[0-9]{2})\n" \
"			)\n" \
"		", "$", NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_regex_new (_tmp21_, G_REGEX_EXTENDED, 0, &_inner_error0_);
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp21_);
		_tmp19_ = _tmp23_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (_tmp13_);
			goto __catch32_g_error;
		}
		_tmp24_ = _tmp19_;
		_tmp19_ = NULL;
		_g_regex_unref0 (gitg_date_s_rfc2822);
		gitg_date_s_rfc2822 = _tmp24_;
		_tmp26_ = g_strconcat ("^\n" \
"			@?\n" \
"			(?<timestamp>[0-9]+)\n" \
"			[ ](?<tz>\n" \
"				[+-](?<tzhour>[0-9]{2})\n" \
"				(?:\n" \
"					:?\n" \
"					(?<tzminute>[0-9]{2})?\n" \
"				)\n" \
"			)\n" \
"		", "$", NULL);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_regex_new (_tmp27_, G_REGEX_EXTENDED, 0, &_inner_error0_);
		_tmp29_ = _tmp28_;
		_g_free0 (_tmp27_);
		_tmp25_ = _tmp29_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (_tmp19_);
			_g_regex_unref0 (_tmp13_);
			goto __catch32_g_error;
		}
		_tmp30_ = _tmp25_;
		_tmp25_ = NULL;
		_g_regex_unref0 (gitg_date_s_internal);
		gitg_date_s_internal = _tmp30_;
		_g_regex_unref0 (_tmp25_);
		_g_regex_unref0 (_tmp19_);
		_g_regex_unref0 (_tmp13_);
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp31_ = e;
		_tmp32_ = _tmp31_->message;
		_tmp33_ = string_to_string (_tmp32_);
		_tmp34_ = g_strconcat ("Failed to compile date regex: ", _tmp33_, NULL);
		_tmp35_ = _tmp34_;
		g_warning ("gitg-date.vala:135: %s", _tmp35_);
		_g_free0 (_tmp35_);
		_g_error_free0 (e);
	}
	__finally32:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}


static void
gitg_date_g_initable_interface_init (GInitableIface * iface)
{
	gitg_date_g_initable_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) gitg_date_real_init;
}


static void
gitg_date_instance_init (GitgDate * self)
{
	self->priv = GITG_DATE_GET_PRIVATE (self);
}


static void
gitg_date_finalize (GObject * obj)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DATE, GitgDate);
	_g_date_time_unref0 (self->priv->d_datetime);
	_g_free0 (self->priv->_date_string);
	G_OBJECT_CLASS (gitg_date_parent_class)->finalize (obj);
}


GType
gitg_date_get_type (void)
{
	static volatile gsize gitg_date_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_date_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgDateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_date_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDate), 0, (GInstanceInitFunc) gitg_date_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) gitg_date_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gitg_date_type_id;
		gitg_date_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgDate", &g_define_type_info, 0);
		g_type_add_interface_static (gitg_date_type_id, g_initable_get_type (), &g_initable_info);
		g_once_init_leave (&gitg_date_type_id__volatile, gitg_date_type_id);
	}
	return gitg_date_type_id__volatile;
}


static void
_vala_gitg_date_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
	switch (property_id) {
		case GITG_DATE_DATE_STRING_PROPERTY:
		g_value_set_string (value, gitg_date_get_date_string (self));
		break;
		case GITG_DATE_DATE_PROPERTY:
		g_value_set_boxed (value, gitg_date_get_date (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_gitg_date_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
	switch (property_id) {
		case GITG_DATE_DATE_STRING_PROPERTY:
		gitg_date_set_date_string (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



